require "pail"

blockStore = {} --keeps inactive blocks
activeShape = {} --keeps active (moving) blocks
activePos = {} --keeps position of active block
controls = {} --table of controls
angle = 0 --remnant of stupid rotation
difficulty = 0.05 --smooth falling, better way to do difficulty
score = 0
h = LG.getHeight()
w = LG.getWidth()
--pail keypad configuration
keypad={
up	= {w/6,h/4*1  ,h/4},
down	= {w/6,h/4*3  ,h/4},
left	= {0,h/4*2  ,h/4},
right	= {w/6*2,h/4*2  ,h/4},
}


function love.load()
pail.load()
--better random

math.randomseed( os.time() ) 
math.random(100)
math.random(100)
math.random(100)


--initialize controls table

controls.left = function ()
if not checkCollide(-1,0) then
activePos[1] = activePos[1] -1
end
cancelButton("left")
end

controls.right = function ()
if not checkCollide(1,0) then
activePos[1] = activePos[1] +1
end
cancelButton("right")
end

controls.down = function ()
if not checkCollide(0,2) then
activePos[2] = activePos[2] +2
end
cancelButton("down")
end

controls.up = function ()
if not checkCollide(-1,0) then
rotateShape()
end
cancelButton("up")
end

makeField() --generate playing field
generateBlock() --load primary block
pail.controls = controls
end

function love.keypressed(key)
  pail.keypressed(key)
  if controls[key] then
    controls[key]()
    end
  end

function love.update(dt)
pail.update(dt)

--love.timer.sleep(500) stupid way to do difficulty

  if checkCollide(0,1) then --checks collision one block below each active block
    for i=1,4 do
      blockStore[activePos[1]+activeShape[1][i]][math.ceil(activePos[2])+activeShape[2][i]] = true --if block collided, unload active block to block store
      end
    checkFilled() --after blocks loaded into block store, check if there are filled lines
    generateBlock() --make a new active block
    else
    activePos[2] = activePos[2]+difficulty --if no collision, move active block down by difficulty level
  end

end

function love.draw(dt)
pail.draw(dt)
love.graphics.print("Score :"..score,100,50)

love.graphics.setColor(255,255,255)

for i = 1,12 do --draw innactive blocks
for j = 1,28 do
      if blockStore[i][j] then love.graphics.circle("fill",i*20,j*20,10)
      end
    end
  end 

for i = 1,4 do --draw active blocks
      love.graphics.setColor(255,0,0) --make active blocks a different color
      love.graphics.circle("fill",(activePos[1]+activeShape[1][i])*20,(activePos[2]+activeShape[2][i])*20,10)
    end
end


function makeField()

  for i = 1,12 do
    blockStore[i] = {}
    for j = 1,28 do
      if i == 1 or i == 12 or j == 28 then
      blockStore[i][j] = true;
      end
    end
  end
end

function generateBlock()

  angle = 0
  activePos={6,1}

--block shape primatives

l = {{0,0,0,1},{-1,0,1,1}}
i = {{-1,0,1,2},{0,0,0,0}}
j = {{0,0,0,-1},{-1,0,1,1}}
b = {{0,1,0,1},{0,1,1,0}}
z = {{-1,0,0,1},{0,0,1,1}}
t = {{-1,0,0,1},{0,0,1,0}}
f = {{-1,0,0,1},{1,1,0,0}}

  typeStore={l,i,j,b,z,t,f}
  ran = math.random(7) --select random block
  --ran = 4 easy debug :)
  selected = typeStore[ran]
  activeShape = selected --put selected block primative into the active slot

end

function checkCollide(i,j)

  for x=1,4 do
    changedPos = activePos
      if blockStore[activePos[1]+activeShape[1][x]+i][math.ceil(activePos[2])+activeShape[2][x]+j] then
      return true
    end
  end
  return false
end
    
function rotateShape()

  centre = {activeShape[1][2],activeShape[2][2]}
  angle = (math.pi/2)
  for i=1,4 do
    rotatedPoint = doRotate({activeShape[1][i],activeShape[2][i]},centre)
    --print(rotatedPoint[1])
    activeShape[1][i] = math.floor(rotatedPoint[1]+0.5)
    activeShape[2][i] = math.floor(rotatedPoint[2]+0.5)
  end

end
  
function doRotate(point,centre)

           rotatedPointx = point[1] * math.cos(angle) - point[2] * math.sin(angle)
           rotatedPointy = point[1] * math.sin(angle) + point[2] * math.cos(angle)
           
	   return {rotatedPointx,rotatedPointy}
	   
end

function checkFilled()
  for i = 1, 27 do
    j = 1
    while blockStore[j][i] == true do
      if j == 12 then
	clearline(i)
	score = score + 1
	break
      else j = j + 1
      end
    end
  end
end

function clearline(x)
  i = x
  
  while i >= 0 do 

    for j = 2, 11 do
      blockStore[j][i] = blockStore[j][i-1] --replace line contents with line above
    end
  i = i - 1
  
  end
end

function love.mousereleased()
pail.mousereleased()
end

function love.mousepressed(button)
pail.mousepressed(button)
end

function love.keyreleased(button)
pail.keyreleased(button)
end